<template src="./template.html"></template>

<script lang="ts">
import { Watch, getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import _ from "lodash";
import { getTimeZone } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");

interface IBodyCreate {
  code: string;
  discount: number;
  status: boolean;
  discountType: number;
  dateFrom: string;
  dateTo?: string;
  minAmount: number;
  minQuantity: number;
}

@Component({})
export default class AdminDiscountCreateComponent extends Vue {
  discount = {
    code: "",
    discount: 0,
    status: true,
    discountType: "1",
    minAmount: 0,
    minQuantity: 0,
  };

  checkboxMinimum = "1";
  minimumRequire = 0;

  isShowDateEnd = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz
    .tz(this.timezoneCountry)
    .endOf("day")
    .format("YYYY-MM-DD");
  dateEnd = momentz
    .tz(this.timezoneCountry)
    .endOf("month")
    .format("YYYY-MM-DD");

  menuTimePickerStart = false;
  menuTimePickerEnd = false;
  timePickerStart = momentz.tz(this.timezoneCountry).format("HH:mm");
  timePickerEnd = momentz.tz(this.timezoneCountry).format("HH:mm");

  loading = false;

  get timezone() {
    return this.$store.state.setting.siteInfo.timezone || "-7";
  }

  get timezoneCountry() {
    return getTimeZone(this.$store.state.setting.timezone) || "US/Arizona";
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  created() {
    this.onSetTime();
  }

  async onCreate() {
    try {
      if (!this.discount.code) {
        return this.$pushNotification.error("Please enter discount code");
      } else if (
        this.discount.discountType !== "3" &&
        !this.discount.discount
      ) {
        return this.$pushNotification.error("Please enter discount value");
      } else if (
        this.discount.discountType === "1" &&
        (this.discount.discount < 0 || this.discount.discount > 100)
      ) {
        return this.$pushNotification.error(
          "Discount value cannot be less than 0 and greater than 100"
        );
      }
      let body: IBodyCreate = {
        ...this.discount,
        minAmount: this.checkboxMinimum === "2" ? this.minimumRequire : 0,
        minQuantity: this.checkboxMinimum === "3" ? this.minimumRequire : 0,
        discountType: parseInt(this.discount.discountType),
        dateFrom: moment(this.from).unix(),
      };

      if (this.isShowDateEnd) {
        body.dateTo = moment(this.to).unix();
      }
      this.loading = true;
      await this.$api.AdminDiscount.addDiscount(body);
      this.$pushNotification.success("Create discount successfully");
      this.discount = {
        code: "",
        discount: 0,
        status: true,
        discountType: "1",
        minAmount: 0,
        minQuantity: 0,
      };
      this.$router.push("/seller/discounts");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onSetTime() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
      timeFrom: this.timePickerStart,
      timeTo: this.timePickerEnd,
    });
  }

  @Watch("dateStart")
  onChagedDateStart() {
    this.onSetTime();
  }

  @Watch("dateEnd")
  onChagedDateEnd() {
    this.onSetTime();
  }

  @Watch("timePickerStart")
  onChagedTimeStart() {
    this.onSetTime();
  }

  @Watch("timePickerEnd")
  onChagedTimeEnd() {
    this.onSetTime();
  }

  @Watch("discount.code")
  changedCodeName(value: string) {
    this.discount.code = value.toLocaleUpperCase();
  }
}
</script>

<style></style>
